#!/usr/bin/perl
#
# SmoothWall CGIs
#
# This code is distributed under the terms of the GPL
#
# (c) The SmoothWall Team
# Copyright (c) 2002/04/13 Steve Bootes - Add source IP support
#
# $Id: iifled.cgi,v 0.3. 2005/09/30 12:00:00 sef Exp $
#
	

require '/var/ipcop/general-functions.pl';
require "${General::swroot}/lang.pl";
require "${General::swroot}/header.pl";

my (%cgiparams,%selected,%checked);

my $configfile = "${General::swroot}/iifled/config";
my $ifacefile = "${General::swroot}/red/iface";
my $errormessage = '';
my $iifSettingsCGI = '/cgi-bin/iifled.cgi';


&Header::showhttpheaders();

&Header::getcgihash(\%cgiparams);
&General::readhash("${General::swroot}/ethernet/settings", \%netconfig);

&Header::openpage($Lang::tr{'iifled configuration'}, 1, '');
&Header::openbigbox('100%', 'left');

open(FILE, "$ifacefile");
$RED_IF = <FILE>;
close(FILE);
if ($RED_IF eq ''){
    $RED_IF = $netconfig{'RED_DEV'};
}

if ($cgiparams{'ACTION'} eq $Lang::tr{'iifled action'} )
{

    open(FILE, ">$configfile") or die 'Unable to open config file.';
    my @current = <FILE>;

# Num LED
    if ( $cgiparams{'IF_NUM_IF'} eq 'none'){
        $cgiparams{'IF_NUM_IF'} = '';
    }
    print FILE "NumIf=$cgiparams{'IF_NUM_IF'}\n";
    print FILE "NumFkt=$cgiparams{'IF_NUM_FKT'}\n";
    print FILE "NumOpt=";
    if ( $cgiparams{'IF_NUM_OPT1'}){
        print FILE "i";
    }
    if ( $cgiparams{'IF_NUM_OPT2'}){
        print FILE "a";
    }
    print FILE "\n";
    
# Caps LED
    if ( $cgiparams{'IF_CAPS_IF'} eq 'none'){
        $cgiparams{'IF_CAPS_IF'} = '';
    }
    print FILE "CapsIf=$cgiparams{'IF_CAPS_IF'}\n";
    print FILE "CapsFkt=$cgiparams{'IF_CAPS_FKT'}\n";
    print FILE "CapsOpt=";
    if ( $cgiparams{'IF_CAPS_OPT1'}){
        print FILE "i";
    }
    if ( $cgiparams{'IF_CAPS_OPT2'}){
        print FILE "a";
    }
    print FILE "\n";

# Scroll LED
    if ( $cgiparams{'IF_SCROLL_IF'} eq 'none'){
        $cgiparams{'IF_SCROLL_IF'} = '';
    }
    print FILE "ScrollIf=$cgiparams{'IF_SCROLL_IF'}\n";
    print FILE "ScrollFkt=$cgiparams{'IF_SCROLL_FKT'}\n";
    print FILE "ScrollOpt=";
    if ( $cgiparams{'IF_SCROLL_OPT1'}){
        print FILE "i";
    }
    if ( $cgiparams{'IF_SCROLL_OPT2'}){
        print FILE "a";
    }
    print FILE "\n";
    close(FILE);
#    print "File was writen.";

    if ( $cgiparams{'ACTIVATE'}){
	system('/usr/local/bin/setiifled restart >/dev/null');
	print "iifled was restarted.";
    }
}

&General::readhash("${General::swroot}/iifled/config", \%iiconfig);

if ($errormessage) {
    &Header::openbox('100%', 'left', $Lang::tr{'error messages'});
    print "<class name='base'><font color='$colourred'>$errormessage\n</font>";
    print "&nbsp;</class>\n";
    &Header::closebox();
}

&Header::openbox('100%', 'left', $Lang::tr{'key LED config'});

print <<END;
    <form method='post' action='$iifSettingsCGI'>
    <br><hr size='1'>
END

$LEDNR_IF = 'IF_NUM_IF';
$LEDNR_FKT = 'IF_NUM_FKT';
$LEDNR_OPT = 'IF_NUM_OPT';
&cleanParams;
$LEDNR_IF1 = 'NumIf';
$LEDNR_FKT1 = 'NumFkt';
$LEDNR_OPT1 = 'NumOpt';
&SetParams;
$LEDNR_OPTI = 'IF_NUM_OPT1';
$LEDNR_OPTA = 'IF_NUM_OPT2';

print <<END;
    $Lang::tr{'num key is'}$status $iiconfig{'NumIf'} 
    $Lang::tr{'key funktion'}$status $iiconfig{'NumFkt'} 
END
&PrintParams;

$LEDNR_IF = 'IF_CAPS_IF';
$LEDNR_FKT = 'IF_CAPS_FKT';
$LEDNR_OPT = 'IF_CAPS_OPT';
&cleanParams;
$LEDNR_IF1 = 'CapsIf';
$LEDNR_FKT1 = 'CapsFkt';
$LEDNR_OPT1 = 'CapsOpt';
&SetParams;
$LEDNR_OPTI = 'IF_CAPS_OPT1';
$LEDNR_OPTA = 'IF_CAPS_OPT2';

print <<END;
    $Lang::tr{'caps key is'}$status $iiconfig{'CapsIf'} 
    $Lang::tr{'key funktion'}$status $iiconfig{'CapsFkt'} 
END
&PrintParams;

&SetParams;
$LEDNR_IF = 'IF_SCROLL_IF';
$LEDNR_FKT = 'IF_SCROLL_FKT';
$LEDNR_OPT = 'IF_SCROLL_OPT';
&cleanParams;
$LEDNR_IF1 = 'ScrollIf';
$LEDNR_FKT1 = 'ScrollFkt';
$LEDNR_OPT1 = 'ScrollOpt';
&SetParams;
$LEDNR_OPTI = 'IF_SCROLL_OPT1';
$LEDNR_OPTA = 'IF_SCROLL_OPT2';

print <<END;
    $Lang::tr{'scroll key is'}$status $iiconfig{'ScrollIf'} 
    $Lang::tr{'key funktion'}$status $iiconfig{'ScrollFkt'} 
END
&PrintParams;

print <<END;
    <br>
    <center>
		<input type='checkbox' name='ACTIVATE' />
		&nbsp;$Lang::tr{'adsl protocol'}Neustart&nbsp;<BR>
	<input type='submit' name='ACTION' value=$Lang::tr{'iifled action'} />
    </form>
END

&Header::closebox();

&Header::closebigbox();
&Header::closepage();

sub cleanParams
{
    if ($netconfig{'GREEN_DEV'}){
	$selected{$LEDNR_IF}{$netconfig{'GREEN_DEV'}} = '';
    }
    if ($netconfig{'ORANGE_DEV'}){
	$selected{$LEDNR_IF}{$netconfig{'ORANGE_DEV'}} = '';
    }
    if ($netconfig{'BLUE_DEV'}){
	$selected{$LEDNR_IF}{$netconfig{'BLUE_DEV'}} = '';
    }
    if ($netconfig{'RED_DEV'}){
	$selected{$LEDNR_IF}{$netconfig{'RED_DEV'}} = '';
    }
    $selected{$LEDNR_IF}{$RED_IF} = '';

    $selected{$LEDNR_FKT}{'r'} = '';
    $selected{$LEDNR_FKT}{'t'} = '';
    $selected{$LEDNR_FKT}{'u'} = '';
    $selected{$LEDNR_FKT}{'i'} = '';
    $selected{$LEDNR_FKT}{'j'} = '';
    $selected{$LEDNR_FKT}{'k'} = '';
    $selected{$LEDNR_FKT}{'e'} = '';
    $selected{$LEDNR_FKT}{'i'} = '';
    $selected{$LEDNR_FKT}{'a'} = '';
    $selected{$LEDNR_FKT}{'c'} = '';
    $selected{$LEDNR_FKT}{'l'} = '';

    $checked{$LEDNR_OPT}{'i'} = '';
    $checked{$LEDNR_OPT}{'a'} = '';
}

sub SetParams
{
    $selected{$LEDNR_IF}{$iiconfig{$LEDNR_IF1}} = 'selected';
    $selected{$LEDNR_FKT}{$iiconfig{$LEDNR_FKT1}} = 'selected';

    if ( $iiconfig{$LEDNR_OPT1} eq 'i' || $iiconfig{$LEDNR_OPT1} eq 'ia' ){
        $checked{$LEDNR_OPT}{'i'} = 'checked';
    }
    if ( $iiconfig{$LEDNR_OPT1} eq 'a' || $iiconfig{$LEDNR_OPT1} eq 'ia' ){
        $checked{$LEDNR_OPT}{'a'} = 'checked';
    }
}

sub PrintParams
{
#    $Lang::tr{'num key is'}$status $iiconfig{$LEDNR_IF1} 
#    $Lang::tr{'num key funktion'}$status $iiconfig{$LEDNR_FKT1} 
#END
    if ( $iiconfig{$LEDNR_OPT1} eq 'i' || $iiconfig{$LEDNR_OPT1} eq 'a' || $iiconfig{$LEDNR_OPT1} eq 'ia' ){
	print "$Lang::tr{'num key option'}$status $iiconfig{$LEDNR_OPT1}";
    }
    print ".";
print <<END;
    <table width='100%'>
	<tr>
	    <td width='35%'  align='center'> 
		<select name=$LEDNR_IF>
		    <option value='none' $selected{$LEDNR_IF}{'none'}>none</option>
		    <option value=$netconfig{'GREEN_DEV'} $selected{$LEDNR_IF}{$netconfig{'GREEN_DEV'}}>Green ($netconfig{'GREEN_DEV'})</option>
END
if ($netconfig{'ORANGE_DEV'}){
print <<END;
		    <option value=$netconfig{'ORANGE_DEV'} $selected{$LEDNR_IF}{$netconfig{'ORANGE_DEV'}}>Orange ($netconfig{'ORANGE_DEV'})</option>
END
}
if ($netconfig{'BLUE_DEV'}){
print <<END;
		    <option value=$netconfig{'BLUE_DEV'} $selected{$LEDNR_IF}{$netconfig{'BLUE_DEV'}}>Blue ($netconfig{'BLUE_DEV'})</option>
END
}
#if ($netconfig{'RED_DEV'}){
#print <<END;
#		    <option value=$netconfig{'RED_DEV'} $selected{$LEDNR_IF}{$netconfig{'RED_DEV'}}>Red $netconfig{'RED_DEV'}</option>
#END
#}
if ($RED_IF){
print <<END;
		    <option value=$RED_IF $selected{$LEDNR_IF}{$RED_IF}>Red ($RED_IF)</option>
END
}
print <<END;
		</select>
	    </td>
	    <td width='35%' align='left'> 
		<select name=$LEDNR_FKT>
		    <option value='r' $selected{$LEDNR_FKT}{'r'}>Receive</option>
		    <option value='t' $selected{$LEDNR_FKT}{'t'}>Transmit</option>
		    <option value='u' $selected{$LEDNR_FKT}{'u'}>Drop Receive</option>
		    <option value='i' $selected{$LEDNR_FKT}{'i'}>Drop Transmit</option>
		    <option value='j' $selected{$LEDNR_FKT}{'j'}>Error Receive</option>
		    <option value='k' $selected{$LEDNR_FKT}{'k'}>Error Transmit</option>
		    <option value='e' $selected{$LEDNR_FKT}{'e'}>Error</option>
		    <option value='d' $selected{$LEDNR_FKT}{'i'}>Drop</option>
		    <option value='a' $selected{$LEDNR_FKT}{'a'}>Activity</option>
		    <option value='c' $selected{$LEDNR_FKT}{'c'}>Collision</option>
	    	    <option value='l' $selected{$LEDNR_FKT}{'l'}>Link Red</option>
#END
#if ( $iiconfig{'NumIf'} eq 'ippp0' || $iiconfig{'NumIf'} eq 'ppp0' || $cgiparams{'IF_NUM_IF'} eq 'ippp0' || $cgiparams{'IF_NUM_IF'} eq 'ppp0'){
#print <<END;
	    	    <option value='l' $selected{$LEDNR_FKT}{'l'}>Link Red</option>
#END
#}
		</select>
	    </td>
	    <td width='30%' align='left'> 
		<input type='checkbox' name=$LEDNR_OPTI $checked{$LEDNR_OPT}{'i'} />
		&nbsp;$Lang::tr{'adsl protocol'}Inverted&nbsp;<BR>
		<input type='checkbox' name=$LEDNR_OPTA $checked{$LEDNR_OPT}{'a'} />
		&nbsp;$Lang::tr{'adsl protocol'}Alternate&nbsp;
	    </td>	
        </tr>
    </table>
    <hr size='1'>
END
}